import java.awt.datatransfer.*;
import java.util.*;
import javax.swing.*;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import java.awt.Toolkit;
import java.awt.event.*;

/**
 * Very simple program for copying control characters to the clipboard.
 */
public class EvilClipboard implements ActionListener {
    
    /** default vector of options */
    private static Vector evilItems = new Vector();
    static {
        // our favourites
        evilItems.add(new EvilItem(0, "Null"));
        evilItems.add(new EvilItem(7, "Bell"));
        evilItems.add(new EvilItem(8, "Backspace"));
        evilItems.add(new EvilItem(33, "Escape"));
        // exaustive list
        evilItems.add(new EvilItem(00, "00 NUL Null"));
        evilItems.add(new EvilItem(01, "01 SOH Start of Heading"));
        evilItems.add(new EvilItem(02, "02 STX Start of Text"));
        evilItems.add(new EvilItem(03, "03 ETX End of Text"));
        evilItems.add(new EvilItem(04, "04 EOT End of Transmission"));
        evilItems.add(new EvilItem(05, "05 ENQ Enquiry"));
        evilItems.add(new EvilItem(06, "06 ACK Acknowledge"));
        evilItems.add(new EvilItem(07, "07 BEL Bell"));
        evilItems.add(new EvilItem(8, "08 BS  Backspace"));
        evilItems.add(new EvilItem(9, "09 TAB Horizontal Tab"));
        evilItems.add(new EvilItem(10, "10 LF  NL Line Feed, New Line"));
        evilItems.add(new EvilItem(11, "11 VT  Vertical Tab"));
        evilItems.add(new EvilItem(12, "12 FF  NP Form Feed, New Page"));
        evilItems.add(new EvilItem(13, "13 CR  Carriage Return"));
        evilItems.add(new EvilItem(14, "14 SO  Shift Out"));
        evilItems.add(new EvilItem(15, "15 SI  Shift In"));
        evilItems.add(new EvilItem(16, "16 DLE Data Link Escape"));
        evilItems.add(new EvilItem(17, "17 DC1 Device Control 1"));
        evilItems.add(new EvilItem(18, "18 DC2 Device Control 2"));
        evilItems.add(new EvilItem(19, "19 DC3 Device Control 3"));
        evilItems.add(new EvilItem(20, "20 DC4 Device Control 4"));
        evilItems.add(new EvilItem(21, "21 NAK Negative Acknowledge"));
        evilItems.add(new EvilItem(22, "22 SYN Synchronous Idle"));
        evilItems.add(new EvilItem(23, "23 ETB End of Transmission Block"));
        
        evilItems.add(new EvilItem(24, "24 CAN Cancel"));
        evilItems.add(new EvilItem(25, "25 EM  End of Medium"));
        evilItems.add(new EvilItem(26, "26 SUB Substitute"));
        evilItems.add(new EvilItem(27, "27 ESC Escape"));
        evilItems.add(new EvilItem(28, "28 FS  File Separator"));
        evilItems.add(new EvilItem(29, "29 GS  Group Separator"));
        evilItems.add(new EvilItem(30, "30 RS  Record Separator"));
        evilItems.add(new EvilItem(31, "31 US  Unit Separator"));
    }
    
    /** combo for selecting an item */
    private JComboBox evilItemSelect;
    
    /**
     * Show a window with the evil clipboard display.
     */
    private void show() {
        
        // create a combo box to select an item
        evilItemSelect = new JComboBox(evilItems);
        
        // create a copy button to fire a copy action
        JButton copyButton = new JButton("Copy");
        copyButton.addActionListener(this);
        
        // create a label with instructions
        JLabel instructions = new JLabel("Copy and paste a control character into any application or web form!");
        
        // create a panel
        JPanel panel = new JPanel();
        panel.setLayout(new GridBagLayout());
        panel.add(evilItemSelect, new GridBagConstraints(0, 0, 1, 1, 1.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(2, 2, 2, 2), 0, 0));
        panel.add(copyButton,     new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(2, 2, 2, 2), 0, 0));
        panel.add(instructions,   new GridBagConstraints(0, 1, 2, 1, 1.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(2, 2, 2, 2), 0, 0));
        
        // create a frame
        JFrame frame = new JFrame("Evil Clipboard");
        frame.setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
        frame.setSize(480, 100);
        frame.getContentPane().setLayout(new GridBagLayout());
        frame.getContentPane().add(panel, new GridBagConstraints(0, 0, 1, 1, 1.0, 1.0, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
        frame.show();
    }
    
    /**
     * When the copy button is pressed, copy to the clipboard.
     */
    public void actionPerformed(ActionEvent e) {
        EvilItem selected = (EvilItem)evilItemSelect.getSelectedItem();
        setClipboard(selected.getCodeString());
    }
    
    /**
     * Sets the contents of the clipboard to the following string.
     */
    private static void setClipboard(String value) {
        try {
            Toolkit.getDefaultToolkit().getSystemClipboard().setContents(new StringSelection(value), null);
        } catch(Exception e) {
            System.out.println("Failed to access clipboard");
        }
    }

    /**
     * An option to copy to the clipboard.
     */
    private static class EvilItem {
        int code;
        String name;
        public EvilItem(int code, String name) {
            this.code = code;
            this.name = name;
        }
        public String getCodeString() {
            return "" + (char)code;
        }
        public String toString() {
            return name;
        }
    }
    
    public static void main(String[] args) throws Exception {
        new EvilClipboard().show();
    }
}                                                                                                                                                                                  
